import { system, world } from "@minecraft/server";

system.runInterval(() => world.getAllPlayers().forEach(player => {
    const dashDirection = player.getViewDirection()
    let air_dash_anim = "animation.player.air_dash";
    if (!player.hasTag("DisableAirDash") && (player.hasTag("cd_jump") || player.hasTag("cd_jump_v")) && !player.hasTag("cd_air_dash_v") && player.hasTag("AirDash4") && player.isFalling && player.isSneaking && !player.isInWater) {
        player.applyKnockback(dashDirection.x, dashDirection.z, 4, 0);
        //        player.addEffect("invisibility", 10, { amplifier: 0, showParticles: false });
        player.dimension.spawnParticle('fiery:wind_double_jump', {
            x: player.location.x,
            y: player.location.y + 1,
            z: player.location.z
        });
        player.addTag('cd_air_dash_v');
        player.playSound('air.dash');
        player.playAnimation(air_dash_anim, {
            blendOutTime: 0.2
        });
    } if (!player.hasTag("DisableAirDash") && (player.hasTag("cd_jump") || player.hasTag("cd_jump_v")) && !player.hasTag("cd_air_dash_v") && !player.hasTag("cd_air_dash") && player.hasTag("AirDash3") && player.isFalling && player.isSneaking && !player.isInWater) {
        player.applyKnockback(dashDirection.x, dashDirection.z, 3.5, 0);
        player.addTag('cd_air_dash');
        player.playSound('air.dash');
        player.dimension.spawnParticle('fiery:wind_double_jump', {
            x: player.location.x,
            y: player.location.y + 1,
            z: player.location.z
        });
        player.playAnimation(air_dash_anim, {
            blendOutTime: 0.2
        });
    } if (!player.hasTag("DisableAirDash") && (player.hasTag("cd_jump") || player.hasTag("cd_jump_v")) && !player.hasTag("cd_air_dash_v") && !player.hasTag("cd_air_dash") && player.hasTag("AirDash2") && player.isFalling && player.isSneaking && !player.isInWater) {
        player.applyKnockback(dashDirection.x, dashDirection.z, 3, 0);
        player.addTag('cd_air_dash');
        player.playSound('air.dash');
        player.dimension.spawnParticle('fiery:wind_double_jump', {
            x: player.location.x,
            y: player.location.y + 1,
            z: player.location.z
        });
        player.playAnimation(air_dash_anim, {
            blendOutTime: 0.2
        });
    } if (!player.hasTag("DisableAirDash") && (player.hasTag("cd_jump") || player.hasTag("cd_jump_v")) && !player.hasTag("cd_air_dash_v") && !player.hasTag("cd_air_dash") && player.hasTag("AirDash1") && player.isFalling && player.isSneaking && !player.isInWater) {
        player.applyKnockback(dashDirection.x, dashDirection.z, 2.5, 0);
        player.addTag('cd_air_dash');
        player.playSound('air.dash');
        player.dimension.spawnParticle('fiery:wind_double_jump', {
            x: player.location.x,
            y: player.location.y + 1,
            z: player.location.z
        });
        player.playAnimation(air_dash_anim, {
            blendOutTime: 0.2
        });
    } if (!player.hasTag("DisableAirDash") && (player.hasTag("cd_jump") || player.hasTag("cd_jump_v")) && !player.hasTag("cd_air_dash_v") && !player.hasTag("cd_air_dash") && player.hasTag("AirDash0") && player.isFalling && player.isSneaking && !player.isInWater) {
        player.applyKnockback(dashDirection.x, dashDirection.z, 2, 0);;
        player.addTag('cd_air_dash');
        player.playSound('air.dash');
        player.dimension.spawnParticle('fiery:wind_double_jump', {
            x: player.location.x,
            y: player.location.y + 1,
            z: player.location.z
        });
        player.playAnimation(air_dash_anim, {
            blendOutTime: 0.2
        });
    } if ((player.hasTag("cd_air_dash") || player.hasTag("cd_air_dash_v")) && player.isOnGround) {
        player.removeTag('cd_air_dash');
        player.removeTag('cd_air_dash_v');
    }
}), 1);
