import { system, world } from "@minecraft/server";

system.runInterval(() => world.getAllPlayers().forEach(player => {
    let double_jump_anim = "animation.player.double_jump";
    if (!player.hasTag("DisableDoubleJump") && !player.hasTag("cd_jump_v") && player.hasTag("DoubleJump4") && player.isFalling && player.isJumping && !player.isInWater) {
        player.applyKnockback(0, 0, 3, 1.05);
        //        player.addEffect("invisibility", 30, { amplifier: 0, showParticles: false });
        player.dimension.spawnParticle('fiery:wind_double_jump', {
            x: player.location.x,
            y: player.location.y,
            z: player.location.z
        });
        player.addTag('cd_jump_v');
        player.playSound('double.jump');
        player.playAnimation(double_jump_anim, {
            blendOutTime: 0.4
        });
    } if (!player.hasTag("DisableDoubleJump") && !player.hasTag("cd_jump_v") && !player.hasTag("cd_jump") && player.hasTag("DoubleJump3") && player.isFalling && player.isJumping && !player.isInWater) {
        player.applyKnockback(0, 0, 2, 0.95);
        player.addTag('cd_jump');
        player.playSound('double.jump');
        player.dimension.spawnParticle('fiery:wind_double_jump', {
            x: player.location.x,
            y: player.location.y,
            z: player.location.z
        });
        player.playAnimation(double_jump_anim, {
            blendOutTime: 0.4
        });
    } if (!player.hasTag("DisableDoubleJump") && !player.hasTag("cd_jump_v") && !player.hasTag("cd_jump") && player.hasTag("DoubleJump2") && player.isFalling && player.isJumping && !player.isInWater) {
        player.applyKnockback(0, 0, 2, 0.85);
        player.addTag('cd_jump');
        player.playSound('double.jump');
        player.dimension.spawnParticle('fiery:wind_double_jump', {
            x: player.location.x,
            y: player.location.y,
            z: player.location.z
        });
        player.playAnimation(double_jump_anim, {
            blendOutTime: 0.4
        });
    } if (!player.hasTag("DisableDoubleJump") && !player.hasTag("cd_jump_v") && !player.hasTag("cd_jump") && player.hasTag("DoubleJump1") && player.isFalling && player.isJumping && !player.isInWater) {
        player.applyKnockback(0, 0, 2, 0.7);
        player.addTag('cd_jump');
        player.playSound('double.jump');
        player.dimension.spawnParticle('fiery:wind_double_jump', {
            x: player.location.x,
            y: player.location.y,
            z: player.location.z
        });
        player.playAnimation(double_jump_anim, {
            blendOutTime: 0.4
        });
    } if (!player.hasTag("DisableDoubleJump") && !player.hasTag("cd_jump_v") && !player.hasTag("cd_jump") && player.hasTag("DoubleJump0") && player.isFalling && player.isJumping && !player.isInWater) {
        player.applyKnockback(0, 0, 2, 0.55);
        player.addTag('cd_jump');
        player.playSound('double.jump');
        player.dimension.spawnParticle('fiery:wind_double_jump', {
            x: player.location.x,
            y: player.location.y,
            z: player.location.z
        });
        player.playAnimation(double_jump_anim, {
            blendOutTime: 0.4
        });
    } if ((player.hasTag("cd_jump") || player.hasTag("cd_jump_v")) && player.isOnGround) {
        player.removeTag('cd_jump');
        player.removeTag('cd_jump_v');
    }
}), 1);
